#!/usr/bin/env bash

RUNS=5

# transaction with many subxacts

for i in $(seq 1 $RUNS); do

	# transaction with many subxacts
	t=$(psql test < subxact.sql 2>&1 | grep Time | awk '{print $2}')
	echo subxacts master $i $t

	# one large transaction
	t=$(psql test < large.sql 2>&1 | grep Time | awk '{print $2}')
	echo large master $i $t

	# many small transactions
	pgbench -i -s 10 test > /dev/null 2>&1
	psql test < recreate-slot.sql > /dev/null 2>&1
	pgbench -c 64 -t 1000 test > /dev/null 2>&1

	t=$(psql test < consume-slot.sql 2>&1 | grep Time | awk '{print $2}')
        echo small master $i $t

done

for i in $(seq 1 $RUNS); do

        # transaction with many subxacts
        t=$(psql -p 5433 test < subxact.sql 2>&1 | grep Time | awk '{print $2}')
        echo subxacts patched $i $t

        # one large transaction
        t=$(psql -p 5433 test < large.sql 2>&1 | grep Time | awk '{print $2}')
        echo large patched $i $t

        # many small transactions
        pgbench -p 5433 -i -s 10 test > /dev/null 2>&1
        psql -p 5433 test < recreate-slot.sql > /dev/null 2>&1
        pgbench -p 5433 -c 64 -t 1000 test > /dev/null 2>&1

        t=$(psql -p 5433 test < consume-slot.sql 2>&1 | grep Time | awk '{print $2}')
        echo small patched $i $t

done
