select pg_drop_replication_slot('slot');

select pg_create_logical_replication_slot('slot', 'test_decoding');

drop table if exists test;

create table test (c int);

create or replace function testfn (cnt int) returns void as $$
begin
  for i in 1..cnt loop
    begin
      insert into test values (i);
    exception when division_by_zero then
      raise notice 'caught error';
      return;
    end;
  end loop;
end;
$$
language plpgsql;

select testfn(100000);

set logical_decoding_work_mem to '4MB';

\timing on

select count(*) from pg_logical_slot_peek_changes('slot', null, null)
